// MusicTimeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MusicTime.h"
#include "MusicTimeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// O SCOPE DOS DSP TEM DE SER GLOBAL ??? 
// no funciona a partir de uma classe... ento temos de definir globalmente...
void	* VULevelDSP( void * In, void * Out, int Length, int param );
short	Compress(const short & in,const double & AVL);
int		vuL,vuR;			// VU Metter ( Left / Right )
BOOL	pkL,pkR;			// Peak detector ( >95% )
BOOL	compander;			// Compander ON/OFF flag
double	Gdb;				// Gain "db" ( not realy dB... )
const double PI=atan(1)*4;	// PI value...for compressor ( my technique )
char	mem[MAXZ];			// Auxiliary space.

// DEFINIES DO AVL / AVL DEFINITIONS ( Auto Volume Level )

#define	MAXPEAK 28000	// Max limit level to trigger decrement of Gdb
#define MEDPEAK 15000	// Med level to trigger increment of Gdb(useful to classic music)
#define PEAKDETECTOR 30000	// LED Peak level indicator.

#define DEFAULTSTARTFOLDER "H:\\MPEG AUDIO\\*.MP*"

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMusicTimeDlg dialog

CMusicTimeDlg::CMusicTimeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMusicTimeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMusicTimeDlg)
	m_fname = _T(DEFAULTSTARTFOLDER);
	m_compander = FALSE;
	m_Gdb = 0.0;
	m_aCrossFade = FALSE;
	m_crxTime = 5000;
	m_subDir = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	SYSFALSE=FALSE;
	if(!FSOUND_Init(44100,2,0))SYSFALSE=TRUE;
	vuL.SetCorner(20,225);
	vuR.SetCorner(20,355);
	::vuL=::vuR=0;
	srand( (unsigned)time( NULL ) );
}


CMusicTimeDlg::~CMusicTimeDlg()
{
	FSOUND_Close();	
}


void CMusicTimeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMusicTimeDlg)
	DDX_Control(pDX, IDC_LIST_FILES, m_fileList);
	DDX_Control(pDX, IDC_SLIDER_PANPOT2, m_panPot2);
	DDX_Control(pDX, IDC_PROGRESS_MUSIC2, m_ProgMusic2);
	DDX_Control(pDX, IDC_SLIDER_PANPOT1, m_panPot1);
	DDX_Control(pDX, IDC_SLIDER_SPECTGAIN, m_spectGain);
	DDX_Control(pDX, IDC_PROGRESS_MUSIC1, m_ProgMusic1);
	DDX_Text(pDX, IDC_EDIT_FILENAME, m_fname);
	DDX_Check(pDX, IDC_CHECK_COMPANDER, m_compander);
	DDX_Text(pDX, IDC_COUT_GDB, m_Gdb);
	DDX_Check(pDX, IDC_CHECK_AUTOCROSSF, m_aCrossFade);
	DDX_Text(pDX, IDC_EDIT_CXTime, m_crxTime);
	DDV_MinMaxUInt(pDX, m_crxTime, 2000, 15000);
	DDX_Check(pDX, IDC_CHECK_SUBDIR, m_subDir);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMusicTimeDlg, CDialog)
	//{{AFX_MSG_MAP(CMusicTimeDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_BROWSE, OnButtonBrowse)
	ON_BN_CLICKED(IDC_BUTTON_PLAY1, OnButtonPlay1)
	ON_BN_CLICKED(IDC_BUTTON_STOP1, OnButtonStop1)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER_SPECTGAIN, OnReleasedcaptureSliderSpectgain)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER_PANPOT1, OnReleasedcaptureSliderPanpot1)
	ON_BN_CLICKED(IDC_BUTTON_PANCENTER1, OnButtonPancenter1)
	ON_BN_CLICKED(IDC_CHECK_COMPANDER, OnCheckCompander)
	ON_BN_CLICKED(IDC_BUTTON_FADEOUT1, OnButtonFadeout1)
	ON_BN_CLICKED(IDC_BUTTON_PLAY2, OnButtonPlay2)
	ON_BN_CLICKED(IDC_BUTTON_STOP2, OnButtonStop2)
	ON_BN_CLICKED(IDC_BUTTON_FADEIN2, OnButtonFadein2)
	ON_BN_CLICKED(IDC_BUTTON_FADEOUT2, OnButtonFadeout2)
	ON_BN_CLICKED(IDC_BUTTON_FADEIN1, OnButtonFadein1)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER_PANPOT2, OnReleasedcaptureSliderPanpot2)
	ON_BN_CLICKED(IDC_BUTTON_PANCENTER2, OnButtonPancenter2)
	ON_BN_CLICKED(IDC_BUTTON_CROSSFADE1, OnButtonCrossfade1)
	ON_BN_CLICKED(IDC_BUTTON_CROSSFADE2, OnButtonCrossfade2)
	ON_BN_CLICKED(IDC_BUTTON_AUTOCROSSFADE, OnButtonAutocrossfade)
	ON_BN_CLICKED(IDC_BUTTON_RANDOMIZE, OnButtonRandomize)
	ON_BN_CLICKED(IDC_BUTTON_ADDFILE, OnButtonAddfile)
	ON_BN_CLICKED(IDC_BUTTON_ADDDIR, OnButtonAdddir)
	ON_BN_CLICKED(IDC_BUTTON_EXECUTELIST, OnButtonExecutelist)
	ON_BN_CLICKED(IDC_BUTTON_CANCEL, OnButtonCancelList)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_LBN_DBLCLK(IDC_LIST_FILES, OnDblclkListFiles)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMusicTimeDlg message handlers

BOOL CMusicTimeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	// TODO: Add extra initialization here
	PLAY1=PLAY2=FALSE;
	FADEIN1=FADEIN2=FADEOUT1=FADEOUT2=FALSE;
	ChVol1=ChVol2=0;
	VUDSP=NULL;
	VURESET=TRUE;
	LOCK=FALSE;
	SetTimer(IDC_TIMER,25,NULL);
	m_spectGain.SetRange(0,95);
	m_spectGain.SetPos(45);
	float merda=500.0f; // no fao a minima ideia da palavra...acho que  isso mesmo.
	vuL.SetSpectScale(merda);
	vuR.SetSpectScale(merda);
	m_panPot1.SetRange(0,255);
	m_panPot1.SetPos(128);
	m_panPot2.SetRange(0,255);
	m_panPot2.SetPos(128);
	FSOUND_SetPan(CH2,FSOUND_STEREOPAN);
	FSOUND_SetPan(CH1,FSOUND_STEREOPAN);
	Gdb=0;
	CreateValidExtensions();
	OnCheckCompander();
	EXECUTE=FALSE;
	if(SYSFALSE)MessageBox("Erro ao iniciar o FMOD.DLL","Tem que sair do programa.",MB_ICONASTERISK);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMusicTimeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMusicTimeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
		CClientDC dcP(this);
		vuL.SetParentWindow(dcP);
		vuL.DrawBox();
		vuL.RedrawArrow();
		vuR.SetParentWindow(dcP);
		vuR.DrawBox();
		vuR.RedrawArrow();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMusicTimeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMusicTimeDlg::OnButtonBrowse() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	// retirar o ficheiro da path... e colocar *.mp* ...
	CString OldPath=m_fname;
	KillPathFile(m_fname,_T("\\*.mp*"));
	if(!Browse(m_fname))m_fname=OldPath;
	UpdateData(FALSE);
}

void CMusicTimeDlg::OnButtonPlay1() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if(m_fname=="")return;
	if(PLAY1)OnButtonStop1();
	// Abrir o ficheiro.
	stream1=FSOUND_Stream_OpenFile(LPCTSTR(m_fname),
		FSOUND_LOOP_OFF,
		0);
	if(stream1==NULL)return;
	// e colocar em PLAY...
	FSOUND_Stream_Play(CH1,stream1);
	if(!FADEIN1)ChVol1=255;
	FSOUND_SetVolume(CH1,ChVol1);
	sizeTMS1=FSOUND_Stream_GetLengthMs(stream1);
	m_ProgMusic1.SetRange(0,100);
	m_ProgMusic1.SetPos(0);
	spectrum=FSOUND_DSP_GetFFTUnit();
	if(FSOUND_DSP_GetActive(spectrum)==FALSE)
	{
		FSOUND_DSP_SetActive(spectrum,TRUE);
	}
	PLAY1=TRUE;
	FADEOUT1=FALSE;
	CreateVUDSP();
}

void CMusicTimeDlg::OnButtonStop1() 
{
	// TODO: Add your control notification handler code here
	if(!PLAY1)return;
	FADEOUT1=PLAY1=FALSE;
	KillVUDSP();
	m_ProgMusic1.SetPos(0);
	ChVol1=255;
	FSOUND_Stream_Stop(stream1);
}

void CMusicTimeDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CClientDC	dcP(this);
	BOOL		ICONIC;
	if(LOCK)goto TIMER_EXIT;
	LOCK=TRUE;
	ICONIC=!IsIconic();
	vuL.SetParentWindow(dcP);
	vuR.SetParentWindow(dcP);
	// MessageBox("Hold");
	int	curTMS;
	if(PLAY1 || PLAY2)
	{
		// ALGUM EST EM PLAY
		// vuL.Cycle(FSOUND_GetCurrentVU(0)); // isto era dantes...
		if(ICONIC)
		{
			ProcessVU(vuL,::vuL);
			ProcessVU(vuR,::vuR);
		}
		// mostrar os picos, se houver.
		if(::pkL){vuL.PeakLed(TRUE);::pkL=FALSE;}
		if(::pkR){vuR.PeakLed(TRUE);::pkR=FALSE;}
	}
	else 
	{
		// ESTAO AMBOS EM STOP
		if(ICONIC)
		{
			vuL.Cycle(0);
			vuR.Cycle(0);
		}
	}
	//
	if(PLAY1)
	{	
		float pos=(float)(curTMS=FSOUND_Stream_GetTime(stream1));
		pos/=(float)sizeTMS1;
		if( m_aCrossFade && 
			(sizeTMS1-curTMS<(int)m_crxTime) && 
			!FADEOUT1 )OnButtonCrossfade1();
		pos*=100;
		m_ProgMusic1.SetPos((int)pos);
		if(!(PLAY1=FSOUND_IsPlaying(CH1)) && EXECUTE)
		{
			// Para o caso do FMOD nao reportar correctamente a durao do ficheiro.
			PLAY1=TRUE;
			if(!FADEOUT1)OnButtonCrossfade1();
			PLAY1=FADEOUT1=FADEIN1=FALSE;
		};
		if(FADEOUT1)
		{
			if((ChVol1-=2)<=0) // FadeOut speed...
			{
				OnButtonStop1();	// Not intended for CrossFade ... yet.
			}
			else FSOUND_SetVolume(CH1,ChVol1);
		}
		if(FADEIN1)
		{
			if((ChVol1+=2)>=255) // FadeIn speed...
			{
				FADEIN1=FALSE;
				ChVol1=255;
			}
			FSOUND_SetVolume(CH1,ChVol1);
		}
	}
	if(PLAY2)
	{
		float pos=(float)(curTMS=FSOUND_Stream_GetTime(stream2));
		pos/=(float)sizeTMS2;
		if(	m_aCrossFade &&
			(sizeTMS2-curTMS<(int)m_crxTime) &&
			!FADEOUT2 )OnButtonCrossfade2();
		pos*=100;
		m_ProgMusic2.SetPos((int)pos);
		if(!(PLAY2=FSOUND_IsPlaying(CH2)) && EXECUTE)
		{
			// Para o caso do FMOD nao reportar correctamente a durao do ficheiro.
			PLAY2=TRUE;
			if(!FADEOUT2)OnButtonCrossfade2();
			PLAY2=FADEOUT2=FADEIN2=FALSE;
		};
		if(FADEOUT2)
		{
			if((ChVol2-=2)<=0) // FadeOut speed...
			{
				OnButtonStop2();	// Not intended for CrossFade ... yet.
			}
			else FSOUND_SetVolume(CH2,ChVol2);
		}
		if(FADEIN2)
		{
			if((ChVol2+=2)>=255) // FadeIn speed...
			{
				FADEIN2=FALSE;
				ChVol2=255;
			}
			FSOUND_SetVolume(CH2,ChVol2);
		}
	}
	// Mostrar o DSP_SPECTRUM ( FMOD s nos d o global e fazer um em stereo d trabalho... )
	if(ICONIC)vuL.DrawSpectrum(FSOUND_DSP_GetSpectrum());
	// Primeira ocorrencia...
	if(VURESET)
	{
		vuL.ResetVu();
		vuR.ResetVu();
		VURESET=FALSE;
	}
	// de 20 em 20 ciclos para no sobrecarregar o Update...
	if(times++>20)
	{
		UpdateData();
		m_Gdb=::Gdb;
		UpdateData(FALSE);
		times=0;
	}
	LOCK=FALSE;
TIMER_EXIT:
	CDialog::OnTimer(nIDEvent);
}

void CMusicTimeDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	// TODO: Add your message handler code here
	KillTimer(IDC_TIMER);
}

void CMusicTimeDlg::OnReleasedcaptureSliderSpectgain(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	float	scale=100.0f-(float)m_spectGain.GetPos();
	scale*=10.0f;
	vuL.SetSpectScale(scale);
	UpdateData(FALSE);
	*pResult = 0;
}

void CMusicTimeDlg::OnReleasedcaptureSliderPanpot1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	int	pan=m_panPot1.GetPos();
	FSOUND_SetPan(CH1,pan);
	UpdateData(FALSE);
	*pResult = 0;
}

void CMusicTimeDlg::OnButtonPancenter1() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	FSOUND_SetPan(CH1,FSOUND_STEREOPAN);
	m_panPot1.SetPos(128);
	UpdateData(FALSE);
}

//*****************************************************************************

short Compress(const short & in,const double & AVL)
{
	// Audio-Compressor, simpler, (C) Jorge Miguel Ferreira.
	// Processo de compresso por curva circular...
	//						^out	-------
	//						+	 /--	
	//						+  /-
	//						+/
	//       -------------------------------->in
	//					   /+
	//					-/	+
	//				 --/	+
	//		---------		+
	// COMPRESSOR STAGE
	double comp=(double)in,angle;
	if(compander)
	{
		angle=comp/65536.0f;
		angle*=PI;
		comp=32768.0f*sin(angle);
	}
	// GAIN (AVL) STAGE (Gdb)
	comp*=exp(AVL);
	return (short)comp;
}

void * VULevelDSP( void * In, void * Out, int Length, int param ) 
{ 
	// Calculo de volume...
	int Ctr = Length;
	short	AvL=0,AvR=0,aux;
	short * Data = ( short * ) In ; 
	while ( Ctr -- ) 
	{ 
		// LEFT ...
		aux=(*(Data++)=Compress(*Data,Gdb));
		if(aux<0)aux=-aux;
		if(aux>AvL)AvL=(AvL+aux)/2;
		// RIGHT ...
		aux=(*(Data++)=Compress(*Data,Gdb));
		if(aux<0)aux=-aux;
		if(aux>AvR)AvR=(AvR+aux)/2;
	} 
	if(AvL>vuL)vuL=AvL;
	if(AvR>vuR)vuR=AvR;
	if(AvL>PEAKDETECTOR)pkL=TRUE;
	if(AvR>PEAKDETECTOR)pkR=TRUE;
	//
	// short	medium=(AvL+AvR)/2;
	// (AvL + AvR ) doesn't work well if PAN not centered...at full RIGHT, or
	// LEFT because it gonna amplify twice the other channel...
	// MEDIUM-MAX Val=25000 to void audio-peaks output.
	short medium=AvL;
	if(AvR>medium)medium=AvR;
	if(compander)
	{
		if(medium>MAXPEAK)Gdb-=0.025f;
		else if(medium>MEDPEAK)Gdb+=0.001f;
	}
	else
	{
		if(medium>MAXPEAK)Gdb-=0.025f;
		else if(medium>MEDPEAK)Gdb+=0.0001f;

	}
	return In ; 
} 

void CMusicTimeDlg::ProcessVU(CVUMetter &meter, int & vuLevel)
{
	meter.Cycle((float)vuLevel/32768.0f);
	vuLevel=0;
}

void CMusicTimeDlg::OnCheckCompander() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	::compander=m_compander;
}

void CMusicTimeDlg::OnButtonFadeout1() 
{
	// TODO: Add your control notification handler code here
	FADEOUT1=TRUE;
	ChVol1=FSOUND_GetVolume(CH1);
}

void CMusicTimeDlg::CreateVUDSP()
{
	if(VUDSP!=NULL)return; // Already active...return.
	VUDSP = FSOUND_DSP_Create( VULevelDSP, FSOUND_DSP_DEFAULTPRIORITY_USER, 0 ) ; 
	FSOUND_DSP_SetActive( VUDSP, TRUE ); 
}

void CMusicTimeDlg::KillVUDSP()
{
	if(PLAY2||PLAY1)return;
	FSOUND_DSP_SetActive( VUDSP, FALSE );
	FSOUND_DSP_Free(VUDSP);
	VUDSP=NULL;
}

void CMusicTimeDlg::OnButtonPlay2() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if(m_fname=="")return;
	if(PLAY2)OnButtonStop2();
	// Abrir o ficheiro.
	stream2=FSOUND_Stream_OpenFile(LPCTSTR(m_fname),
		FSOUND_LOOP_OFF,
		0);
	if(stream2==NULL)return;
	// e colocar em PLAY...
	FSOUND_Stream_Play(CH2,stream2);
	if(!FADEIN2)ChVol2=255;
	FSOUND_SetVolume(CH2,ChVol2);
	sizeTMS2=FSOUND_Stream_GetLengthMs(stream2);
	m_ProgMusic2.SetRange(0,100);
	m_ProgMusic2.SetPos(0);
	spectrum=FSOUND_DSP_GetFFTUnit();
	if(FSOUND_DSP_GetActive(spectrum)==FALSE)
	{
		FSOUND_DSP_SetActive(spectrum,TRUE);
	}
	PLAY2=TRUE;
	FADEOUT2=FALSE;
	CreateVUDSP();	
}

void CMusicTimeDlg::OnButtonStop2() 
{
	// TODO: Add your control notification handler code here
	if(!PLAY2)return;
	FADEOUT2=PLAY2=FALSE;
	KillVUDSP();
	m_ProgMusic2.SetPos(0);
	ChVol2=255;
	FSOUND_Stream_Stop(stream2);	
}

void CMusicTimeDlg::OnButtonFadein2() 
{
	// TODO: Add your control notification handler code here
	FADEIN2=TRUE;
	if(!FADEOUT2)ChVol2=0;
	else FADEOUT2=FALSE;
	FSOUND_SetVolume(CH2,ChVol2);
	if(!PLAY2)OnButtonPlay2();	
}

void CMusicTimeDlg::OnButtonFadeout2() 
{
	// TODO: Add your control notification handler code here
	FADEOUT2=TRUE;
	ChVol2=FSOUND_GetVolume(CH2);	
}

void CMusicTimeDlg::OnButtonFadein1() 
{
	// TODO: Add your control notification handler code here
	FADEIN1=TRUE;
	if(!FADEOUT1)ChVol1=0;
	else FADEOUT1=FALSE;
	FSOUND_SetVolume(CH1,ChVol1);
	if(!PLAY1)OnButtonPlay1();
}

void CMusicTimeDlg::OnReleasedcaptureSliderPanpot2(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	int	pan=m_panPot2.GetPos();
	FSOUND_SetPan(CH2,pan);
	UpdateData(FALSE);
	*pResult = 0;
}

void CMusicTimeDlg::OnButtonPancenter2() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	FSOUND_SetPan(CH2,FSOUND_STEREOPAN);
	m_panPot2.SetPos(128);
	UpdateData(FALSE);	
}

void CMusicTimeDlg::OnButtonCrossfade1() 
{
	// TODO: Add your control notification handler code here
	if(PLAY1|| !PLAY2)
	{
		OnButtonFadein2();
		OnButtonFadeout1();
		if(EXECUTE)
		{
			UpdateData();
			m_fname=NextMusic();
			UpdateData(FALSE);
		}
	}
}

void CMusicTimeDlg::OnButtonCrossfade2() 
{
	// TODO: Add your control notification handler code here
	if(PLAY2|| !PLAY1)
	{
		OnButtonFadein1();
		OnButtonFadeout2();
		if(EXECUTE)
		{
			UpdateData();
			m_fname=NextMusic();
			UpdateData(FALSE);
		}
	}	
}	

void CMusicTimeDlg::OnButtonAutocrossfade() 
{
	// TODO: Add your control notification handler code here
	if(!(PLAY1 ^ PLAY2))return;
	if(PLAY1)OnButtonCrossfade1();
	else	 OnButtonCrossfade2();
}

void CMusicTimeDlg::PushDir(const char *dir, const BOOL &recurse)
{
	// Empilhar DIR/FICHEIROS para a lista de ficheiros.
	CFileFind	hook;
	CString		fname;
	BOOL		fh=hook.FindFile(dir);
	indexPar	par;
	while(fh)
	{
		// Fetch do ficheiro e guardar o estado.
		fh=hook.FindNextFile();
		// obter o "DIR\FICHEIRO"
		if(hook.IsDirectory())
		{
			if(!recurse)continue;
			//if(*(LPCTSTR(hook.GetFileName()))=='.')continue;
			if(hook.IsDots())continue;
			CString type=dir;
			OnlyFilename(type);
			fname=hook.GetFilePath();
			fname+='\\';
			fname+=type;
			PushDir(fname,recurse);
			continue;
		}
		fname=hook.GetFilePath();
		// fname.MakeUpper(); // Transformar a maiusculas os nomes dos ficheiros.
		// obter a extenso e verificar se  vlida.
		const char * ptr=LPCTSTR(fname);
		while(*ptr)ptr++; // fim da string.
		while(*ptr!='.')ptr--; // procurar a extenso.
		// mas converter a extenso a MAIUSCULAS para poder haver confirmao
		// do tipo ".mp3" = ".MP3" e no diferente como seria normal...
		CString	ext=ptr;
		ext.MakeUpper();
		if(!exts[LPCTSTR(ext)].valid)continue;
		// obter o index...
		par.first=musicas.size();
		par.second.fname=fname;
		musicas.insert(par);
		m_fileList.AddString(fname);
	};
	hook.Close();
}

void CMusicTimeDlg::OnlyFilename(CString &obj)
{
	// Destroy path from full dir/filename.
	char * ptr=mem,c;
	strncpy(mem,LPCTSTR(obj),MAXZ);
	while(*ptr)ptr++;
	ptr--;
	while((c=*ptr))
	{
		if(c=='\\')
		{
			obj=ptr+1;
			return;
		}
		ptr--;
		if(ptr<mem)break;
	}
}

CString CMusicTimeDlg::RandMusic()
{
	UINT size=musicas.size(),t,tmax,rand;
	Musica		* ptr;
	if(!size)return _T("");
	// Procurar no mtodo randomico
	for(t=0,tmax=size*10;t<tmax;t++)
	{
		rand=Random(size);
		ptr=&(musicas[rand]);
		if(!ptr->usada)
		{
			ptr->usada=TRUE;
			return ptr->fname;
		}
	}
	// procurar no metodo linear...
	for(t=0;t<size;t++)
	{
		ptr=&(musicas[t]);
		if(!ptr->usada)
		{
			ptr->usada=TRUE;
			return ptr->fname;
		}
	}
	// Nao h mais disponibilidade na lista...limpar os indexes e
	// comear de novo!
	for(t=0;t<size;t++)
	{
		musicas[t].usada=FALSE;
	}
	rand=Random(size);
	ptr=&(musicas[rand]);
	ptr->usada=TRUE;
	return ptr->fname;
}

UINT CMusicTimeDlg::Random(const UINT &issue)
{
	double Rand=rand();
	// escalar o randomize 
	double max=RAND_MAX;
	Rand*=issue;
	Rand/=max;
	return (UINT)Rand;
}

void CMusicTimeDlg::OnButtonRandomize() 
{
	// TODO: Add your control notification handler code here
	int	size=musicas.size();
	m_fileList.ResetContent();
	for(int i=0;i<size;i++)
	{
		m_fileList.AddString(RandMusic());
	}
	m_fileList.SetCurSel(0);
}

void CMusicTimeDlg::OnButtonAdddir() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	CString	DDir=m_fname;
	KillPathFile(DDir,_T("\\*.*"));
	if(Browse(DDir))
	{
		KillPathFile(DDir,_T("\\*.*"));
		PushDir(LPCTSTR(DDir),m_subDir);
	}
	UpdateData(FALSE);
}

void CMusicTimeDlg::OnButtonAddfile() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	CString	DFile=m_fname;
	KillPathFile(DFile,_T("\\*.*"));
	if(Browse(DFile))
	{
		PushDir(LPCTSTR(DFile),FALSE);
	}
	UpdateData(FALSE);
}

BOOL CMusicTimeDlg::Browse(CString & Path)
{
	CString Thold=Path;
	CFileDialog dlg(TRUE,NULL,Path,OFN_EXPLORER|
		OFN_NONETWORKBUTTON|OFN_HIDEREADONLY,
		"Ficheiros MPEG(*.mp*)| *.mp*|Ficheiros WAVE (*.wav)| *.wav||",this);
	if(dlg.DoModal()==IDOK)
	{
		Path=dlg.GetPathName();
		return TRUE;
	}
	else Path=Thold;
	return FALSE;
}

void CMusicTimeDlg::CreateValidExtensions()
{
/*
	FILE * fin;
	exts.clear();
	if((fin=fopen("EXTS.TXT","rt"))==NULL)return;
	while(!feof(fin))
	{
		if(FetchFile(fin))break;  //defined extra.fin->mem,fgets...
		if(*mem!='.')continue;
		exts[mem].valid=TRUE;
	}
	fclose(fin);
*/
	exts[_T(".MP1")].valid=TRUE;
	exts[_T(".MP2")].valid=TRUE;
	exts[_T(".MP3")].valid=TRUE;
	exts[_T(".MPA")].valid=TRUE;
	exts[_T(".WAV")].valid=TRUE;
	exts[_T(".RAW")].valid=TRUE;
	exts[_T(".PCM")].valid=TRUE;
	exts[_T(".MPG")].valid=TRUE;
}

void CMusicTimeDlg::KillPathFile(CString &Path,const CString & ins)
{
	const char * ptr=LPCTSTR(Path);
	const char * ini=ptr;
	ptr+=Path.GetLength();
	while(ptr>ini)
	{
		if(*ptr=='\\')break;
		ptr--;
	}
	int len=ptr-ini;
	if(len)
	{
		CString aux=Path.Left(len);
		aux+=ins;
		Path=aux;
	}
}

void CMusicTimeDlg::OnButtonExecutelist() 
{
	// TODO: Add your control notification handler code here
	EXECUTE=TRUE;
	UpdateData();
	m_aCrossFade=TRUE;
	GetDlgItem(IDC_CHECK_AUTOCROSSF)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_CANCEL)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_EXECUTELIST)->EnableWindow(FALSE);
	if(!(PLAY1 || PLAY2))
	{
		m_fname=NextMusic();
		UpdateData(FALSE);
		OnButtonPlay1();
		m_fname=NextMusic();
		UpdateData(FALSE);
	}
	UpdateData(FALSE);
}

void CMusicTimeDlg::OnButtonCancelList() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	EXECUTE=FALSE;
	GetDlgItem(IDC_CHECK_AUTOCROSSF)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_CANCEL)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_EXECUTELIST)->EnableWindow(TRUE);
	UpdateData(FALSE);
}

CString CMusicTimeDlg::NextMusic()
{
	if(m_fileList.GetCount()==0)OnButtonRandomize();
	CString	musica;
	m_fileList.GetText(0,musica);
	m_fileList.DeleteString(0);
	return musica;
}

void CMusicTimeDlg::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	m_fileList.ResetContent();
	musicas.clear();
	UpdateData(FALSE);
}

void CMusicTimeDlg::OnDblclkListFiles() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	int idx=m_fileList.GetCurSel();
	if(idx==LB_ERR)return;
	m_fileList.GetText(idx,m_fname);
	UpdateData(FALSE);
	// Estamos em PlayList ???
	if(EXECUTE)
	{
		OnButtonAutocrossfade();
		return;
	}
	// Estamos em STOP nos dois ???
	if(!(PLAY1 || PLAY2))
	{
		OnButtonPlay1();
		return;
	}
	// Outra situao... nada mais a fazer.
}
