// MusicTimeDlg.h : header file
//

#if !defined(AFX_MUSICTIMEDLG_H__E426EC07_7E39_11D6_86BE_9E5832F9C36B__INCLUDED_)
#define AFX_MUSICTIMEDLG_H__E426EC07_7E39_11D6_86BE_9E5832F9C36B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\fmod\api\inc\fmod.h"
#include "VUMetter.h"
#include <math.h>

#define CH1 0
#define CH2 1
#define MAXZ	1024
/////////////////////////////////////////////////////////////////////////////
// CMusicTimeDlg dialog

#pragma warning(disable:4786)

#include <map>
using namespace std;

struct Musica
{
	CString	fname;
	BOOL	usada;
	Musica(){ usada=FALSE;}

};

struct newBool
{
	BOOL	valid;
	newBool(){ valid=FALSE; }
};
typedef map < UINT , Musica > indexMap;
typedef indexMap::iterator indexIt;
typedef pair < UINT , Musica > indexPar;
typedef map < CString , newBool > extMap;

class CMusicTimeDlg : public CDialog
{
// Construction
public:
	UINT Random(const UINT & issue);
	CMusicTimeDlg(CWnd* pParent = NULL);	// standard constructor
	~CMusicTimeDlg(); // Standard destructor.
// Dialog Data
	//{{AFX_DATA(CMusicTimeDlg)
	enum { IDD = IDD_MUSICTIME_DIALOG };
	CListBox	m_fileList;
	CSliderCtrl	m_panPot2;
	CProgressCtrl	m_ProgMusic2;
	CSliderCtrl		m_panPot1;
	CSliderCtrl		m_spectGain;
	CProgressCtrl	m_ProgMusic1;
	CString			m_fname;
	BOOL			m_compander;
	double			m_Gdb;
	BOOL	m_aCrossFade;
	UINT	m_crxTime;
	BOOL	m_subDir;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMusicTimeDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CMusicTimeDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonBrowse();
	afx_msg void OnButtonPlay1();
	afx_msg void OnButtonStop1();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	afx_msg void OnReleasedcaptureSliderSpectgain(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnReleasedcaptureSliderPanpot1(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnButtonPancenter1();
	afx_msg void OnCheckCompander();
	afx_msg void OnButtonFadeout1();
	afx_msg void OnButtonPlay2();
	afx_msg void OnButtonStop2();
	afx_msg void OnButtonFadein2();
	afx_msg void OnButtonFadeout2();
	afx_msg void OnButtonFadein1();
	afx_msg void OnReleasedcaptureSliderPanpot2(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnButtonPancenter2();
	afx_msg void OnButtonCrossfade1();
	afx_msg void OnButtonCrossfade2();
	afx_msg void OnButtonAutocrossfade();
	afx_msg void OnButtonRandomize();
	afx_msg void OnButtonAddfile();
	afx_msg void OnButtonAdddir();
	afx_msg void OnButtonExecutelist();
	afx_msg void OnButtonCancelList();
	afx_msg void OnButtonClear();
	afx_msg void OnDblclkListFiles();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CString NextMusic();
	void KillPathFile(CString & Path,const CString & ins);
	void CreateValidExtensions();
	BOOL Browse(CString & Path);
	CString RandMusic();
	void OnlyFilename(CString &obj);
	void PushDir(const char *dir, const BOOL &recurse);
	void KillVUDSP();
	void CreateVUDSP();
	int				ChVol1,ChVol2;
	BOOL			FADEOUT1,FADEOUT2;
	BOOL			FADEIN1,FADEIN2;
	void			ProcessVU(CVUMetter & meter,int & vuLevel);
	int				sizeTMS1,sizeTMS2;
	BOOL			PLAY1,VURESET;
	BOOL			PLAY2;
	FSOUND_STREAM	* stream1;
	FSOUND_STREAM	* stream2;
	CVUMetter		vuL;
	CVUMetter		vuR;
	FSOUND_DSPUNIT	* spectrum;
	FSOUND_DSPUNIT	* VUDSP;
	UINT			times;
	BOOL			LOCK,SYSFALSE; // Prevenir TIMER recurse ( @ debug )
	indexMap		musicas;
	extMap			exts;
	BOOL			EXECUTE;
	int				execIdx;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MUSICTIMEDLG_H__E426EC07_7E39_11D6_86BE_9E5832F9C36B__INCLUDED_)
