// VUMetter.h: interface for the CVUMetter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VUMETTER_H__73BE7E83_7F9F_11D6_86BE_C2B6AAE20E58__INCLUDED_)
#define AFX_VUMETTER_H__73BE7E83_7F9F_11D6_86BE_C2B6AAE20E58__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define LARX 150
#define SPEX 256
#define LARY 100
#include <math.h>

class CVUMetter  
{
public:
	void PeakLed(const BOOL & ON);
	void SetSpectScale(float & scale);
	void DrawSpectrum(const float * buffer);
	void Cycle(float level);
	void RedrawArrow();
	void DrawBox();
	void SetCorner(const int & px,const int & py);
	void ResetVu();
	void DrawArrow(const int & dept);
	void SetParentWindow(CClientDC & parent);
	CVUMetter();
	virtual ~CVUMetter();

private:
	void CoSin(const int & Rx,const int & Ry,double fase,int & dx,int & dy);
	int		oldDept;
	CClientDC * pw;
	int		ox,oy,sx;
	double	PI;
	double	kPI;
	int		LvL;
	int		zarc[256];
	float	SpectScale;
	BOOL	PEAK;
};

#endif // !defined(AFX_VUMETTER_H__73BE7E83_7F9F_11D6_86BE_C2B6AAE20E58__INCLUDED_)
